import java.util.*;
import java.lang.*;
import java.math.BigInteger;
public class PrimeFinder{

	static boolean witness(BigInteger a, BigInteger n){
		int t = 0;
		BigInteger u = n.subtract(BigInteger.ONE);
		while(u.mod(new BigInteger("2")).equals(BigInteger.ZERO)){
			u = u.shiftRight(1);
			t++;
		}
		BigInteger[] x = new BigInteger[t+1];
		x[0] = a.modPow(u, n);
		// System.out.println("t = " + t + ", u = " + u);

		for(int i = 1; i <= t; ++i){
			x[i] = x[i - 1].modPow(new BigInteger("2"), n);
			if(x[i].compareTo(BigInteger.ZERO) < 0){
				x[i] = x[i].add(n);
			}
			// System.out.println("x[" + (i-1) + "] = " + x[i-1] + ", x[" + i + "] = " + x[i]);
			if(x[i].equals(BigInteger.ONE) && !x[i-1].equals(BigInteger.ONE) && !x[i-1].equals(n.subtract(BigInteger.ONE)))
				return true;
		}
		if(!x[t].equals(BigInteger.ONE)){
			return true;
		}else{
			return false;
		}
	}

	static BigInteger nextRandomBigInteger(BigInteger n) {
	    Random rand = new Random();
	    BigInteger result = new BigInteger(n.bitLength(), rand);
	    while( result.compareTo(n) >= 0 ) {
	        result = new BigInteger(n.bitLength(), rand);
	    }
	    return result;
	}
	static boolean isPrime(BigInteger n, int s){
		for(int j = 1; j <= s; ++j){
			BigInteger a = nextRandomBigInteger(n.subtract(BigInteger.ONE)).add(BigInteger.ONE); //random(1, n-1)
			if(witness(a, n)){
				// System.out.println("Witness failed" + a + ", " + n);
				return false;
			}
		}
		return true;
	}


	public static void main(String[] args) {
		int length = Integer.parseInt(args[0]);
		int num_trials = Integer.parseInt(args[1]);
		BigInteger base = new BigInteger("2");
		BigInteger number = base.pow(length - 1);
		BigInteger twoToN = base.pow(length);

		// System.out.print("Search from ");
		// System.out.print(number);
		// System.out.print(" to ");
		// System.out.println(twoToN);

		while(number.compareTo(twoToN) < 0){
			if(isPrime(number, num_trials)){
				System.out.println(number.toString(2));
				break;
			}
			number = number.add(BigInteger.ONE);
		}
	}
}